<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Authorization, Content-Type, Access-Control-Allow-Methods");

ini_set('display_errors', '1'); // Disable display of errors on the screen
ini_set('display_startup_errors', '1');
ini_set('log_errors', 1); // Enable error logging

error_reporting(E_ALL);
$path_locl = $_SERVER['DOCUMENT_ROOT'];
include_once $path_locl . '/includes/dbconfig.php';
require $path_locl . '/vendor/autoload.php';


use \Firebase\JWT\JWT;

$gl_crnt_date = m_global_tzf_cfunc();

//AUTH
$secretKey = base64_encode('qwikgigfunnel:u74i^bV&o4$#');

// Replace this with your secret key
$authmatch = 'Bearer ' . $secretKey;

$responseFile = $path_locl.'/briefgenerate/response.txt';


$fp = fopen($responseFile, 'a');

$date = date("Y-m-d H:i:s");

try {
	/*if(true){
		
	 	fwrite($fp, "\n".$date." App ID not found!!");
	 	fwrite($fp, "\n". $date." Testing");
	}*/
	
	if ($fp === false) {
	 throw new Exception("Error: Could not open the file for writing.");
	 die("Error: Could not open the file for writing.");
	}
	//exit();
	

	$headers = getallheaders();
	if (isset($headers['Authorization'])) {
  		$bearer_token = $headers['Authorization'];
  		if ($bearer_token != $authmatch) {
    			//echo 'invalid token324443242';
    			//exit;
    			
    			fwrite($fp, "\n".$date. " Token is Invalid!!");
    			
    			throw new Exception("Token is Invalid!!");
    			echo "Token is Invalid!!";
    			
  		}
	} else {
		
  		//echo 'token missing';
  		//exit;
  		
  		fwrite($fp, "\n".$date . " Token not found!!");
  		
  		throw new Exception("Token not found!!");
  		
  		echo "Token is Invalid!!";
	}
	
	$input = file_get_contents("php://input");
	$jsonDecode = json_decode($input, true);
	
	if (json_last_error() === JSON_ERROR_NONE) {
	
		$_POST = $jsonDecode;
		$json = $input;
		$jdecod = $jsonDecode;
	
		if(empty($jdecod['app_id']) && !array_key_exists('app_id', $jdecod)){
			fwrite($fp, "\n".$date. " App ID not found!!");
			echo "App ID not found!!";
			throw new Exception("App ID not found!!");
		}	
		
		
		if(array_key_exists('app_id', $jdecod) && !empty($jdecod['app_id'])){			
		
			$appid = $jdecod['app_id'];
			$keys = array_keys((array)$jdecod);
			
			if (isset($keys[1]) &&  $keys[1] == 'key') {
			  $servicekey = $keys[2];
			  if ($servicekey == 'question_id') {
			    $servicekey = $keys[2] . $jdecod->question_id;
			  }
			  $response_key = $keys[1];
			  if ($response_key == 'key') {
			    $response_key = $keys[1] . '_' . $jdecod->key;
			  }
			} else {
			  $servicekey = 'common';
			  $response_key = $keys[1];
			}

			$arrslz = serialize($jdecod);
			
			$json_serlz_escaped = $conn->real_escape_string($arrslz);

			$sqlupdate = "INSERT INTO `case_project_scope` (`id`, `case_id`, `service_key`, `response_key`, `business_scope`, `created_at`, `updated_at`) VALUES (NULL, '" . $appid . "', '" . $servicekey . "', '" . $response_key . "', '" . $json_serlz_escaped . "', '" . $gl_crnt_date . "', '" . $gl_crnt_date . "')";
			
			//echo "<pre>";
			//print_r($sqlupdate);
			//print_r(!array_key_exists('app_id', $jdecod));
			//exit();
			
			if ($conn->query($sqlupdate)) {
			  $jsnoutput = '{
				"app_id": "' . $appid . '",
			    }';
			  echo $jsnoutput;
			}else{
				$errorMessage = "";
				
				if($conn->error){
					$errorMessage =  "\n".$date . " Error: ".$conn->error . " Error no. ". $conn->errno;
				}else{
					$errorMessage = "\n".$date .  " DB error not found!";
				}
				
				fwrite($fp, $errorMessage);
				
				$errorQuery = "INSERT INTO `case_send_request_logs` (`heading`, `message`, `created_at`, ) VALUES ('DB Error', $errorMessage, date('Y-m-d H:i:s'))";
				
				$conn->query($errorQuery);
				
				echo $errorMessage;
				
				throw new Exception("Error: ".$conn->error . " Error no. ". $conn->errno);
			}
				
		
		
		}
		
		
	
		
	
	}else{	
		fwrite($fp, "\n".$date .  " JSON is invalid!!".json_last_error());
		
		echo "JSON is invalid!!".json_last_error();
			
		throw new Exception("JSON is invalid!!".json_last_error());	
	}
	
	
    
} catch (Exception $e) {
	
    fwrite($fp, "\n".$date .  " Caught exception: " . $e->getMessage().$e->getLine());
    // Handle the exception
    echo "Caught exception: " . $e->getMessage();
}

fclose($fp);

// $file = 'response.txt';

// // Open the file in write mode
// $fp = fopen($file, 'w');

// fwrite($fp, $jdecod);

// // Close the file
// 


