<?php
header('Content-Type: application/json');
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Authorization, Content-Type, Access-Control-Allow-Methods");

ini_set('display_errors', '1'); // Disable display of errors on the screen
ini_set('display_startup_errors', '1');
ini_set('log_errors', 1); // Enable error logging

error_reporting(E_ALL);
//live- web server path
//$path_locl = $_SERVER['DOCUMENT_ROOT'];
//local - file path
//$path_locl = __DIR__;
$path_locl = $_SERVER['DOCUMENT_ROOT'];
//$responseFile = $path_locl.'/mainfunnel/response.txt';
//$path_locl . '/includes/dbconfig.php';
//$path_locl . '/vendor/autoload.php';
//exit();

include_once $path_locl . '/includes/dbconfig.php';
require $path_locl . '/vendor/autoload.php';


use \Firebase\JWT\JWT;

$gl_crnt_date = m_global_tzf_cfunc();

//AUTH
$secretKey = base64_encode('qwikgigmainfunnel:Q4jI@6!0NxH]');

// Replace this with your secret key
$authmatch = 'Bearer ' . $secretKey;

$responseFile = $path_locl.'/mainfunnel/response.txt';

$fp = fopen($responseFile, 'a');

$date = date("Y-m-d H:i:s");

try {
	
	if($_SERVER['REQUEST_METHOD']=='POST'){
		if ($fp === false) {
		 throw new Exception("Error: Could not open the file for writing.");
		 die("Error: Could not open the file for writing.");
		}
		//exit();
		
		$headers = getallheaders();
		//fwrite($fp, "\n".$date . " Token found!! ".$headers['Authorization']);
		//print_r($headers);
		//throw new Exception("Token found!!".$headers['Authorization']);
		//exit();			

		if (isset($headers['Authorization'])) {
	  		$bearer_token = $headers['Authorization'];
	  		if ($bearer_token != $authmatch) {
	    			//echo 'invalid token324443242';
	    			//exit;    			
	    			fwrite($fp, "\n".$date. " Token is Invalid!!");    			
	    			throw new Exception("Token is Invalid!!");
	    			echo "Token is Invalid!!";    			
	    			
	  		}
		} else {
			
	  		//echo 'token missing';
	  		//exit;
	  		//$headerTest = implode(" - ",$headers['authorization']);
	  		
	  		fwrite($fp, "\n".$date . " Token not found!! ");
	  		
	  		throw new Exception("Token not found!!");
	  		
	  		echo "Token is Invalid!!";
		}

		$input = file_get_contents("php://input");

		$jsonDecode = json_decode($input, true);

		if (json_last_error() === JSON_ERROR_NONE) {
		
			$_POST = $jsonDecode;
			$json = $input;
			$jdecod_data = $jsonDecode;
			//fwrite($fp, "\n".$date. " ".$input);
			
			if(empty($jdecod_data)){
			   echo "JSON Data not found!!";
			   throw new Exception("JSON Data not found!!");
			}
		
			if(empty($jdecod_data['uid']) && !array_key_exists('uid', $jdecod_data)){
				fwrite($fp, "\n".$date. " UID not found!!");
				echo "UID not found!!";
				throw new Exception("App ID not found!!");
			}			
			
			if(array_key_exists('uid', $jdecod_data) && !empty($jdecod_data['uid'])){		
				$appid = $jdecod_data['uid'];
				$title ="";
				if(!empty($jdecod_data['title'])){
					$title = $jdecod_data['title'];
				}

				$ai_overview ="";
				if(!empty($jdecod_data['ai_overview'])){
					$ai_overview = $jdecod_data['ai_overview'];
				}

				$category ="";
				if(!empty($jdecod_data['category'])){
					$category = $jdecod_data['category'];
				}

				$skills ="";
				if(!empty($jdecod_data['skills'])){
					$skills = implode(',', $jdecod_data['skills']);
				}

				$sqlupdate = "INSERT INTO `case_short_project_overview` (`id`,`flow_id`, `guest_id`, `user_id`, `title`, `ai_overview`, `category`, `skills`, `created_at`, `updated_at`) VALUES (NULL, '" . $appid . "', NULL, NULL,'" . $title . "', '" . $ai_overview . "', '" . $category . "', '" . $skills . "', '" . $gl_crnt_date . "', '" . $gl_crnt_date . "')";
				
				//echo "<pre>";
				//print_r($sqlupdate);
				//print_r(!array_key_exists('app_id', $jdecod));
				//exit();
				
				if ($conn->query($sqlupdate)) {
				  $jsnoutput = '{
					"uid": "' . $appid . '",
				    }';
				  echo $jsnoutput;
				  //exit();
				}else{
					$errorMessage = "";
					
					if($conn->error){
						$errorMessage =  "\n".$date . " Error: ".$conn->error . " Error no. ". $conn->errno;
					}else{
						$errorMessage = "\n".$date .  " DB error not found!";
					}
					
					fwrite($fp, $errorMessage);
					
					$errorQuery = "INSERT INTO `case_send_request_logs` (`heading`, `message`, `created_at`, ) VALUES ('DB Error', $errorMessage, date('Y-m-d H:i:s'))";
					
					$conn->query($errorQuery);
					
					echo $errorMessage;
					
					throw new Exception("Error: ".$conn->error . " Error no. ". $conn->errno);
				}
					
			
			
			}
			
		
		}else{	
			fwrite($fp, "\n".$date .  " JSON is invalid!!".json_last_error());
			
			echo "JSON is invalid!!".json_last_error();
				
			throw new Exception("JSON is invalid!!".json_last_error());	
		}
	}else{
		throw new Exception("Something went wrong!!");	
	}
	
	
    
} catch (Exception $e) {
	
    fwrite($fp, "\n".$date .  " Caught exception: " . $e->getMessage().$e->getLine());
    // Handle the exception
    echo "Caught exception: " . $e->getMessage();
}

fclose($fp);

// $file = 'response.txt';

// // Open the file in write mode
// $fp = fopen($file, 'w');

// fwrite($fp, $jdecod);

// // Close the file
// 


